/*
 * Kangaroo Punch MultiPlayer Game Server Mark II
 * Copyright (C) 2020-2021  Scott Duensing
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */


#ifndef OS_H
#define OS_H


// https://sourceforge.net/p/predef/wiki/Architectures/


// Common platform includes.
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/stat.h>


#define SECONDS_IN_DAY    86400
#define TICKS_PER_SECOND  18.2
#define TICKS_PER_DAY     (SECONDS_IN_DAY * TICKS_PER_SECOND)

#define OS_PATH_MAX  256


#ifdef __linux__

#define BITS64
#define OS_PATH_SLASH '/'

// Linux DOS replacements.
uint32_t rawclock(void);

// Linux support functions.
void linuxOsShutdown(void);
void linuxOsStartup(void);

#else

#define BITS32
#define OS_PATH_SLASH '\\'

// DOS includes.
#include <dos.h>
#include <dpmi.h>
#include <go32.h>
#include <bios.h>
#include <conio.h>
#include <sys/farptr.h>
#include <sys/nearptr.h>

#endif

#include "macros.h"

// Now our headers.
#include "packet.h"
#include "cache.h"

#ifndef PacketThreadDataT
typedef struct PacketThreadDataS PacketThreadDataT;
#endif

extern PacketThreadDataT *__packetThreadData;  // Declared in main.c


uint8_t  osFileExists(char *filename);
char    *osLastPathComponentGet(char *pathname);
char    *osLastPathComponentGetUpTo(char *pathname);
int8_t   osMkDir(char *dir);
uint8_t  osMkDirP(char *dir);
void     osPathSeparatorsFix(char **path, uint8_t slash);
void     osShutdown(void);
void     osStartup(void);


#endif // OS_H
